#ifndef _VERTEXARRAY_H
#define _VERTEXARRAY_H

#include <stdio.h>

#include <stdlib.h>
#include <time.h>

#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include <cmath>
#include <cassert>

#include <stdexcept>

#include <vector>
#include <list>
#include <map>

using namespace std;

#include "exception.h"
#include "tester.h"
#include "bipointer.h"

#define MAX_UVSETS 4

class VERTEXARRAY : public BIPOINTER_TARGET
{
private:
	vector < vector <float> > texcoords;
	vector <float> normals;
	vector <float> vertices;
	vector <int> faces;

public:
	VERTEXARRAY() {}
	~VERTEXARRAY() {Clear();}
	
	VERTEXARRAY operator+ (const VERTEXARRAY & v) const;

	const TESTER Test();
	
	void Clear() {texcoords.clear();normals.clear();vertices.clear();faces.clear();}
	
	void SetNormals(float * newarray, unsigned int newarraycount);
	void SetVertices(float * newarray, unsigned int newarraycount);
	void SetFaces(int * newarray, unsigned int newarraycount);
	void SetTexCoordSets(int newtcsets);
	void SetTexCoords(unsigned int set, float * newarray, unsigned int newarraycount); //set is zero indexed
	
	void GetNormals(const float * & output_array_pointer, int & output_array_num) const;
	void GetVertices(const float * & output_array_pointer, int & output_array_num) const;
	void GetFaces(const int * & output_array_pointer, int & output_array_num) const;
	int GetTexCoordSets() const {return texcoords.size();}
	void GetTexCoords(unsigned int set, const float * & output_array_pointer, int & output_array_num) const;
	
	void SetToBillboard(float scale);
};

#endif
