#include "scenegraph.h"
//#include "game.h"
//extern GAME game;
#include "common.h"

const TESTER SCENEGRAPH::Test()
{
	TESTER mytest;
	
	int points = 0;
	
	if (GetRoot().Nodes() == 0) points++;
	SCENENODE & n1 = GetRoot().AddNode();
	if (GetRoot().Nodes() == 1) points++;
	SCENENODE & n2 = GetRoot().AddNode();
	if (GetRoot().Nodes() == 2) points++;
	SCENENODE & n21 = n2.AddNode();
	if (n2.Nodes() == 1) points++;
	n21.AddDrawable();
	if (n21.Drawables() == 1) points++;
	if (n2.Drawables() == 0) points++;
	mytest.SubTestComplete("Scene node and drawable management", points, 6);
	
	/*points = 0;
	VERTEX trans;
	trans.x = 1000;
	n2.GetTransform().SetTranslation(trans);
	list <SCENEDRAW> dlist;
	GetDrawList(dlist);
	if (dlist.size() == 3) points++; //else cout << dlist.size() << endl;
	list <SCENEDRAW>::iterator it = dlist.begin();
	if (it->IsTransform()) points++;
	it++;
	if (it->IsDraw()) points++;
	it++;
	if (it->IsEmpty()) points++;
	mytest.SubTestComplete("Scene draw list generation", points, 4);*/
	
	points = 0;
	DRAWABLE & d11 = n1.AddDrawable();
	Delete(&d11);
	if (n1.Drawables() == 0) points++;
	Delete(&n1);
	if (GetRoot().Nodes() == 1) points++;
	Delete(&n2);
	DRAWABLE & d3 = GetRoot().AddDrawable();
	if (GetRoot().Drawables() == 1) points++;
	Delete(&d3);
	if (GetRoot().Nodes() == 0 && GetRoot().Drawables() == 0) points++;
	mytest.SubTestComplete("Scene node and drawable deletion", points, 4);
	
	points = 0;
	DRAWABLE_FILTER filter;
	filter.SetFilter_is2d(false, false);
	DRAWABLE & d4 = GetRoot().AddDrawable();
	d4.Set2D(false);
	if (filter.Matches(d4)) points++;
	d4.Set2D(true);
	if (filter.Matches(d4)) points++;
	filter.SetFilter_is2d(true, false);
	if (!filter.Matches(d4)) points++;
	d4.Set2D(false);
	if (filter.Matches(d4)) points++;
	mytest.SubTestComplete("Drawable filtering", points, 4);
	
	/*SDL_Init(0);
	{
		points = 0;
		GetRoot().Clear();
		//setup random scene
		const unsigned int num_nodes = 100;
		const unsigned int num_subnodes = 100;
		SCENENODE * nodes[num_nodes];
		for (unsigned int i = 0; i < num_nodes; i++)
		{
			nodes[i] = &(GetRoot().AddNode());
			VERTEX v;
			v.x = 1;
			v.y = 2;
			v.z = 3;
			QUATERNION newq;
			newq.SetAxisAngle(v.x, v.x, v.y, v.z);
			nodes[i]->GetTransform().SetRotation(newq);
			nodes[i]->GetTransform().SetTranslation(v);
			for (unsigned int n = 0; n < num_subnodes; n++)
			{
				SCENENODE & subnode = nodes[i]->AddNode();
				subnode.GetTransform().SetRotation(newq);
				subnode.GetTransform().SetTranslation(v);
				subnode.AddDrawable();
			}
		}
		unsigned int startticks = SDL_GetTicks();
		list <SCENEDRAW> drawlist;
		GetCollapsedDrawList(drawlist);
		//GetDrawList(drawlist);
		unsigned int endticks = SDL_GetTicks();
		stringstream msg;
		msg << "Performance testing scene collapse (" << endticks - startticks << "ms)";
		if (endticks - startticks < 100)
			points++;
		mytest.SubTestComplete(msg.str(), points, 1);
	}
	SDL_Quit();*/
	
	points = 0;
	{
		SCENENODE n1;
		n1.GetTransform().SetTranslation(VERTEX(0,2,0));
		QUATERNION r;
		r.SetAxisAngle(-3.141593*0.5, 0, 0, -1);
		n1.GetTransform().SetRotation(r);
		SCENENODE & n2 = n1.AddNode();
		n2.GetTransform().SetTranslation(VERTEX(0,1,0));
		r.SetAxisAngle(3.141593*0.5, 0, 0, -1);
		n2.GetTransform().SetRotation(r);
		VERTEX v1(0.1,0,0);
		VERTEX v2(0.1,0,0);
		v1 = n2.TransformIntoWorldSpace(v1);
		v2 = n2.TransformIntoLocalSpace(v2);
		if ((v1 - VERTEX(-0.9,2,0)).len() < 0.001 && (v2 - VERTEX(1.1,-2,0)).len() < 0.001) points++;
	}
	mytest.SubTestComplete("Transform into and out of local space", points, 1);

	return mytest;
}

SCENENODE & SCENENODE::AddNode()
{
	{
		SCENENODE newnode;
		childlist.push_back(newnode);
	}
	childlist.back().SetParent(*this);
	return childlist.back();
}

DRAWABLE & SCENENODE::AddDrawable()
{
	{
		DRAWABLE newnode;
		drawlist.push_back(newnode);
	}
	drawlist.back().SetParent(*this);
	return drawlist.back();
}

/*void SCENEGRAPH::GetDrawList(list <SCENEDRAW> & drawlist) const
{
	drawlist.clear();
	
	DRAWABLE_FILTER filter;
	rootnode.GetDrawList(drawlist, filter);
}*/

void SCENENODE::GetDrawList(list <SCENEDRAW> & drawlistoutput, const DRAWABLE_FILTER & filter) const
{
	//TODO:  do something like the below line but better that will exit early
	// if there are no drawables that meet the filter criteria at this node or
	// at any child nodes
	if (drawlist.empty() && childlist.empty())
		return;
	
	bool identitytransform = transform.IsIdentityTransform();
	if (!identitytransform)
	{
		SCENEDRAW newtransform(transform);
		drawlistoutput.push_back(newtransform);
	}
	
	ITERCONST(DRAWABLE,drawlist,i)
	{
		if (i->GetDrawEnable() && filter.Matches(*i))
		{
			SCENEDRAW newdraw(*i);
			drawlistoutput.push_back(newdraw);
		}
	}
	
	ITERCONST(SCENENODE,childlist,i)
	{
		i->GetDrawList(drawlistoutput, filter);
	}
	
	if (!identitytransform)
	{
		SCENEDRAW poptransform;
		drawlistoutput.push_back(poptransform);
	}
}

void SCENEDRAW::DebugPrint() const
{
	cout << "transform: " << transform << ", draw: " << draw << endl;
}

void SCENEGRAPH::Delete(SCENENODE * todelete)
{
	if (todelete == NULL)
		throw EXCEPTION(__FILE__, __LINE__, "Asked to delete NULL");
	SCENENODE * p = todelete->GetParent();
	if (p == NULL)
		throw EXCEPTION(__FILE__, __LINE__, "Parent is NULL");
	p->Delete(todelete);
}

void SCENEGRAPH::Delete(DRAWABLE * todelete)
{
	if (todelete == NULL)
		throw EXCEPTION(__FILE__, __LINE__, "Asked to delete NULL");
	SCENENODE * p = todelete->GetParent();
	if (p == NULL)
		throw EXCEPTION(__FILE__, __LINE__, "Parent is NULL");
	p->Delete(todelete);
}

void SCENENODE::Delete(SCENENODE * todelete)
{
	list <SCENENODE>::iterator itdel = childlist.end();
	ITERATE(SCENENODE,childlist,i)
	{
		if (&(*i) == todelete)
			itdel = i;
	}
	
	if (itdel != childlist.end())
	{
		itdel->Clear(); //optional
		childlist.erase(itdel);
	}
	else
		throw EXCEPTION(__FILE__, __LINE__, "Parent does not contain child");
}

void SCENENODE::Delete(DRAWABLE * todelete)
{
	list <DRAWABLE>::iterator itdel = drawlist.end();
	ITERATE(DRAWABLE,drawlist,i)
	{
		if (&(*i) == todelete)
			itdel = i;
	}
	
	if (itdel != drawlist.end())
	{
		drawlist.erase(itdel);
	}
	else
		throw EXCEPTION(__FILE__, __LINE__, "Parent does not contain child");
}

bool DRAWABLE_FILTER::Matches(const DRAWABLE & drawable) const
{
	if (is2d_filter && is2d != drawable.is2d) return false;
	if (partial_transparency_filter && partial_transparency != drawable.partial_transparency) return false;
	if (blur_filter && blur != drawable.blur) return false;
	if (skybox_filter && skybox != drawable.skybox) return false;
	
	return true;
}

void SCENEGRAPH::GetDrawList(list <DRAWABLE_FILTER *> & filter_list, map < DRAWABLE_FILTER *, list <SCENEDRAW> > & drawlist_output_map) const
{
	drawlist_output_map.clear();
	
	ITERATE(DRAWABLE_FILTER *,filter_list,i)
	{
		list <SCENEDRAW> & outlist = drawlist_output_map[*i];
		rootnode.GetDrawList( outlist, **i);
		//cout << drawlist_output_map[*i].size() << endl;
	}
}

/*void SCENEGRAPH::GetCollapsedDrawList(list <SCENEDRAW> & drawlist) const
{
	drawlist.clear();
	
	MATRIX4 identity;
	DRAWABLE_FILTER filter;
	list <DRAWABLE_FILTER *> filter_list;
	filter_list.push_back(&filter);
	map < DRAWABLE_FILTER *, list <SCENEDRAW> >
	rootnode.GetCollapsedDrawList(drawlist, filter, identity);
}*/

void SCENEGRAPH::GetCollapsedDrawList(list <DRAWABLE_FILTER *> & filter_list, map < DRAWABLE_FILTER *, list <SCENEDRAW> > & drawlist_output_map) const
{
	drawlist_output_map.clear();
	
	ITERATE(DRAWABLE_FILTER *,filter_list,i)
	{
		drawlist_output_map[*i].clear(); //this creates the entry in our map
	}
	
	MATRIX4 identity;
	
	/*ITERATE(DRAWABLE_FILTER *,filter_list,i)
	{
		list <SCENEDRAW> & outlist = drawlist_output_map[*i];
		rootnode.GetCollapsedDrawList(outlist, **i, identity);
		//cout << drawlist_output_map[*i].size() << endl;
	}*/
	
	rootnode.GetCollapsedDrawList(filter_list, drawlist_output_map, identity);
}

void SCENENODE::GetCollapsedDrawList(list <DRAWABLE_FILTER *> & filter_list, map < DRAWABLE_FILTER *, list <SCENEDRAW> > & drawlist_output_map, const MATRIX4 & prev_transform) const
{
	if (drawlist.empty() && childlist.empty())
		return;
	
	MATRIX4 this_transform(prev_transform);
	
	bool identitytransform = transform.IsIdentityTransform();
	if (!identitytransform)
	{
		//MATRIX4 curmat;
		//curmat.Set(this_transform);
		//MATRIX4 transmat;
		//transmat.Translate(transform.GetTranslation());
		MATRIX4 rotmat;
		rotmat.Set(transform.GetRotation());
		rotmat.Translate(transform.GetTranslation());
		
		//this_transform = (rotmat.Multiply(transmat)).Multiply(curmat);
		this_transform = rotmat.Multiply(this_transform);
	}
	
	SCENEDRAW empty;
	
	ITERCONST(DRAWABLE,drawlist,i)
	{
		if (i->GetDrawEnable())
		{
			/*ITERATE(DRAWABLE_FILTER *,filter_list,fi)
			{
				list <SCENEDRAW> & outlist = drawlist_output_map[*fi];
				//cout << "starting push" << endl;
				//SCENEDRAW newdraw(*i, this_transform);
				if ((*fi)->Matches(*i))
					outlist.push_back(SCENEDRAW(*i,this_transform));
				//cout << "ending push" << endl;
			}*/
			
			ITERMAPNOCONST(DRAWABLE_FILTER *, list <SCENEDRAW>, drawlist_output_map, mi)
			{
				if (mi->first->Matches(*i))
				{
					mi->second.push_back(empty);
					mi->second.back().SetCollapsed(*i,this_transform);
					//mi->second.push_back(SCENEDRAW(*i,this_transform));
				}
			}
		}
	}
	
	ITERCONST(SCENENODE,childlist,i)
	{
		i->GetCollapsedDrawList(filter_list, drawlist_output_map, this_transform);
	}
}

MATRIX4 SCENENODE::CollapseTransform() const
{
	list <const SCENENODE *> nodelist;
	const SCENENODE * curnode = this;
	
	while (curnode != NULL)
	{
		nodelist.push_back(this);
		curnode = curnode->parent;
	}
	
	nodelist.reverse();
	
	MATRIX4 outmat;
	ITERATE(const SCENENODE*,nodelist,i)
	{
		MATRIX4 rotmat;
		rotmat.Set((*i)->transform.GetRotation());
		rotmat.Translate((*i)->transform.GetTranslation());
		outmat = rotmat.Multiply(outmat);
	}
	
	return outmat;
}

VERTEX SCENENODE::TransformIntoWorldSpace(const VERTEX & localspace) const
{
	const SCENENODE * curnode = this;
	
	VERTEX pos(localspace);
	
	while (curnode != NULL)
	{
		pos = curnode->transform.GetRotation().RotateVec(pos);
		pos = pos + curnode->transform.GetTranslation();
		
		curnode = curnode->parent;
	}
	
	return pos;
}

VERTEX SCENENODE::TransformIntoLocalSpace(const VERTEX & worldspace) const
{
	VERTEX pos(worldspace);
	
	list <const SCENENODE *> nodelist;
	const SCENENODE * curnode = this;
	
	while (curnode != NULL)
	{
		nodelist.push_back(curnode);
		curnode = curnode->parent;
	}
	
	nodelist.reverse();
	
	//cout << "Started at ";worldspace.DebugPrint();
	
	ITERATE(const SCENENODE*,nodelist,i)
	{
		//cout << "Subtracting ";(*i)->transform.GetTranslation().DebugPrint();
		pos = pos - (*i)->transform.GetTranslation();
		//cout << "Rotating" << endl;
		pos = (*i)->transform.GetRotation().ReturnConjugate().RotateVec(pos);
	}
	
	return pos;
}

const bool DRAWABLE::operator< (const DRAWABLE & other) const
{
	//if (draw_order != other.draw_order)
	//	return (draw_order < other.draw_order);
	
	/*if (diffuse_map.PtrValid() && other.diffuse_map.PtrValid())
		return (diffuse_map.GetPtr()->GetTexture().GetTextureInfo().GetName() < other.diffuse_map.GetPtr()->GetTexture().GetTextureInfo().GetName());*/
	
	//return false;
	
	return (draw_order != other.draw_order ? (draw_order < other.draw_order) : false);
}

const bool SCENEDRAW::operator< (const SCENEDRAW & other) const
{
	if (draw != NULL)
		return ((*draw) < *(other.draw));
	else
		return false;
}

DRAWABLE::~DRAWABLE()
{

}

SCENENODE::~SCENENODE()
{

}

void SCENENODE::DebugPrint()
{
	cout << "Drawables: " << drawlist.size() << endl;
	cout << "Children: " << childlist.size() << endl;
	int count = 1;
	ITERATE(SCENENODE,childlist,i)
	{
		cout << "---start child " << count << "---" << endl;
		i->DebugPrint();
		cout << "+++end child " << count << "+++" << endl;
		
		count++;
	}
}

bool DrawableSort_RenderState (DRAWABLE & first, DRAWABLE & second)
{
	bool b1,b2;
	
	b1 = first.GetPartialTransparency();
	b2 = second.GetPartialTransparency();
	if (b1 != b2)
		return (b1 < b2);
	
	b1 = first.GetSkybox();
	b2 = second.GetSkybox();
	if (b1 != b2)
		return (b1 < b2);
	
	b1 = first.GetLit();
	b2 = second.GetLit();
	if (b1 != b2)
		return (b1 < b2);
	
	b1 = first.GetDecal();
	b2 = second.GetDecal();
	if (b1 != b2)
		return (b1 < b2);
	
	string dmap1(first.GetDiffuseMapName()), dmap2(second.GetDiffuseMapName());
	if (dmap1 != dmap2)
		return (dmap1 < dmap2);
	
	return false;
}

void SCENENODE::SortDrawablesByRenderState()
{
	drawlist.sort(DrawableSort_RenderState);
}
